const char MAIN_page[] PROGMEM = R"=====(
<!DOCTYPE html>
<html>
<style>
card {
     max-width: 1000px;
     height: 25px;
     padding: 0px;
     box-sizing: border-box;
     color: white;
     margin:20px;
     box-shadow: 0px 2px 18px -4px rgba(0,0,0,0.75);
}
.card1{background: #0f5f45;}
.card2{background: #ffffff;}

.card3 {
     max-width: 1000px;
     height: 500px;
     padding: 30px;
     box-sizing: border-box;
     background: #0f5f45;
     margin:20px;
     box-shadow: 0px 2px 18px -4px rgba(0,0,0,0.75);
}

.button0 {
  border: none;
  color: white;
  padding: 30px;
  text-align: center;
  text-decoration: none;
  display: inline-block;
  font-size: 16px;
  margin: 4px 2px;
  cursor: pointer;
}

.button1 {background-color: #4CaF50;}
.button2 {background-color: #008CBA;}


table, th, td {
  border: 1px solid black;
  text-align: center;
}

.wrap-flex { display: flex; justify-content: center; margin: 0 -5px}

</style>

<head>
<title> LoRa Farms </title>
</head>


<body>
<center>
<div class="card card1">
  <h1>Welcome to LoRa Farms!</h1><br>
  <h2> Farm Control Dashboard </h2> <br>
  
</div>

<br>

<h3> Actuator Status </h3>
<button class = "button" onclick = "requestReadings(3)";> Update 3 </button>
<button class = "button" onclick = "requestReadings(2)";> Update 2 </button>
<br>
<table>
  <tr>
    <td> Time </td>
    <td> Device Number </td>
    <td> Battery Level </td>
    <td> Soil Moisture </td>
    <td> Light </td>
    <td> Humidity </td>
    <td> Temperature </td>
    <td> Heat Lamp </td>
    <td> Shade </td>
    <td> Sprinklers </td>
  </tr>
  <tr>
    <td id = "time" rowspan = "2"> -- </td>
    <td > 3 </td>
    <td id = "levelBat3"> -- </td>
    <td id = "moistSoil3"> -- </td>
    <td id = "light3"> -- </td>
    <td id = "humidity3"> -- </td>
    <td id = "temp3"> -- </td>
    <td id = "heatLamp3Stat"> -- </td>
    <td id = "shade3Stat"> -- </td>
    <td id = "sprink3Stat"> -- </td>
  </tr>
  <tr>
    <td > 2 </td>
    <td id = "levelBat2"> -- </td>
    <td id = "moistSoil2"> -- </td>
    <td id = "light2"> -- </td>
    <td id = "humidity2"> -- </td>
    <td id = "temp2"> -- </td>
    <td id = "heatLamp2Stat"> -- </td>
    <td id = "shade2Stat"> -- </td>
    <td id = "sprink2Stat"> -- </td>
</table>
    


<br>


<div class="wrap-flex", style = "text-align: center;">
    <div class = "box", style = "margin: 0 5px;">
      <label for = "deviceNum">Device</label>
      <!-- <select name = "deviceNum" id ="deviceNum">
        <label> Device Number </label>
      </select> -->
        <button onclick="device_select(3)"; > Device 3 </button>
        <button onclick= "device_select(2)";> Device 2 </button>
      </select>
    </div>
    <br>
    <div class = "box", style = "margin: 0 5px;">
      <label for = "heatLamp">Heat Lamp </label>
      <!-- <select name = "heatLamp" id ="heatLamp"> -->
        <!-- <label> Heat Lamp Status </label> -->
        <button onclick = "heatLamp_set(0)";> Off </button>
        <button onclick = "heatLamp_set(1)";> On </button>
      </select>
    </div>
    
    <div class = "box", style = "margin: 0 5px;">
      <label for = "shadeAct">Shade</label>
      <!-- <select name = "shadeAct" id ="shadeAct">
        <label> Shade Value </label> -->
        <button onclick = "shadeAct_set(0)";> Off </button>
        <button onclick="shadeAct_set(1)";> On </button>
      </select>
    </div>
    
    <div class = "box", style = "margin: 0 5px;">
      <label for = "sprinklerAct">Sprinklers</label>
      <!-- <select name = "sprinklerAct" id ="sprinklerAct">
        <label> Sprinkler Value </label> -->
        <button onclick = "sprinklerAct_set(0)";> Off </button>
        <button onclick = "sprinklerAct_set(1)";> On </button>
      </select>
    </div>
  </div>

  <br>

  <table>
    <tr>
      <td id = "deviceHead"> Device Number</td>
      <td id = "heatLampHead"> Heat Lamp </td>
      <td id = "shadeActHead"> Shade </td>
      <td id = "sprinklerActHead"> Sprinklers </td>
    </tr>
    <tr>
      <td id = "deviceCell"> -- </td>
      <td id = "heatLampCell"> -- </td>
      <td id = "shadeActCell"> -- </td>
      <td id = "sprinklerActCell"> -- </td>
    </tr>
  </table>
  
  <br>

  <button class = "button" onclick = "pass()";> Send </button>
  
  <br>
  <br>


<button class = "button0 button1", style = "height:75px; padding:10px" onclick= "table_to_CSV()"> Download Table </button>
<br>


<table>
  <tr>
    <th colspan = "8"> Data Log </th>
  </tr>
  <tbody id ="rows">
    <tr>
      <td id = "date"> Date </td>
      <td id = "time"> Time </td>
      <td id = "device_id"> Sensor ID </td>
      <td id = "battery_value" > Battery Value </td>
      <td id = "moisture_value" > Moisture Value </td>
      <td id = "light_value" > Light Value </td>
      <td id = "humidity_value" > Humidity Value </td>
      <td id = "temperature_value" > Temperature Value </td>
    </tr>
   </tbody>
</table>
  

</center>
<script>

setInterval(function() {
  // Call a function repetatively with 2 Second interval
  getData();
}, 100); //2000mSeconds update rate

function getData() {
  var xhttp = new XMLHttpRequest(); //some AJAX request has a variable name xhttp
  xhttp.onreadystatechange = function() {             //define a function called onreadystatechange
    if (this.readyState == 4 && this.status == 200) {       //check to see when readyState indicates finished and status indicates success
      
      variable = this.responseText; //variable = testArray

        if(this.responseText.charCodeAt(0) == "0x01") {
          //define variable types as rows and cells
          var newRow = document.createElement("tr");
          //var newCell = document.createElement("td");
          var newDate = document.createElement("td");
          var newTime = document.createElement("td");
          var newID = document.createElement("td");
          var newBat = document.createElement("td");
          var newAnal = document.createElement("td");
          var newLight = document.createElement("td");
          var newHum = document.createElement("td");
          var newTemp = document.createElement("td");
    
          //populate cells
          newDate.innerHTML = get_date();
          newTime.innerHTML = get_time();
          newID.innerHTML = this.responseText.charCodeAt(1);
          newBat.innerHTML = this.responseText.charCodeAt(2);
    
          //processing 2-byte values
          var analogValue = Math.round(( (this.responseText.charCodeAt(3) << 7) | (this.responseText.charCodeAt(4)) ) * (65535/16383))/100;
          var lightValue = Math.round(( (this.responseText.charCodeAt(5) << 7) | (this.responseText.charCodeAt(6)) ) * (65535/16383))/100;
          var humValue = (Math.round(( (this.responseText.charCodeAt(7) << 7) | (this.responseText.charCodeAt(8)) ) * (65535/16383))/100);
          var tempValue = (Math.round(( (this.responseText.charCodeAt(9) << 7) | (this.responseText.charCodeAt(10)) ) * (65535/16383))/100);
          var tempComb = (this.responseText.charCodeAt(9) << 7) | (this.responseText.charCodeAt(10));
          console.log("combined bytes:");
          console.log(tempComb);
          var tempUnmap = tempComb * 4;
          console.log("unmapped:");
          console.log(tempUnmap);
          var tempRound = Math.round(tempUnmap);
          var temp2meNice = tempRound/100;
         
          console.log("temp2meNice: ");
          console.log(temp2meNice);
          console.log("temp value: ");
          console.log(tempValue);
          console.log("hi_byte:");
          console.log(this.responseText.charCodeAt(9));
          console.log("lo_byte:");
          console.log(this.responseText.charCodeAt(10));

          
          //plugging 2-byte values into their cells
          newAnal.innerHTML = analogValue;
          newLight.innerHTML = lightValue;
          newHum.innerHTML = humValue;
          newTemp.innerHTML = tempValue;
          
          newRow.append
          newRow.append(newDate);
          newRow.append(newTime);
          newRow.append(newID); //new 
          newRow.append(newBat);
          newRow.append(newAnal); 
          newRow.append(newLight);
          newRow.append(newHum);
          newRow.append(newTemp);
    
          document.getElementById("rows").appendChild(newRow); //rows is the name of the body, so we are adding a new row to the body
        }
      
    }
  };
  xhttp.open("GET", "readADC", true);
  xhttp.send();
}

function requestReadings(deviceNumber) {
  var request = new XMLHttpRequest();
    request.onreadystatechange = function() {
      if(this.readyState == 4 && this.status == 200) {
        
        document.getElementById("time").innerHTML = get_time();
        status = this.responseText;
        if (this.responseText.charCodeAt(1) == 2) {
          document.getElementById("levelBat2").innerHTML = this.responseText.charCodeAt(2);  
          document.getElementById("moistSoil2").innerHTML = Math.round(( (this.responseText.charCodeAt(3) << 7) | (this.responseText.charCodeAt(4)) ) * (65535/16383))/100;
          document.getElementById("light2").innerHTML = Math.round(( (this.responseText.charCodeAt(5) << 7) | (this.responseText.charCodeAt(6)) ) * (65535/16383))/100;
          document.getElementById("humidity2").innerHTML = (Math.round(( (this.responseText.charCodeAt(7) << 7) | (this.responseText.charCodeAt(8)) ) * (65535/16383))/100) + 35;
          document.getElementById("temp2").innerHTML = (Math.round(( (this.responseText.charCodeAt(9) << 7) | (this.responseText.charCodeAt(10)) ) * (65535/16383))/100) + 1.5;
          if(this.responseText.charCodeAt(12) == 0){
            document.getElementById("heatLamp2Stat").innerHTML = "off";
          }
          else if (this.responseText.charCodeAt(12) >= 1){
            document.getElementById("heatLamp2Stat").innerHTML = "on";
          }
          if(this.responseText.charCodeAt(13) == 0){
            document.getElementById("shade2Stat").innerHTML = "off";
          }
          else if (this.responseText.charCodeAt(13) >= 1){
            document.getElementById("shade2Stat").innerHTML = "on";
          }
          // document.getElementById("shade2Stat").innerHTML = this.responseText.charCodeAt(13);
          if(this.responseText.charCodeAt(14) == 0){
            document.getElementById("sprink2Stat").innerHTML = "off";
          }
          else if (this.responseText.charCodeAt(14) >= 1){
            document.getElementById("sprink2Stat").innerHTML = "on";
          }
          //document.getElementById("sprink2Stat").innerHTML = this.responseText.charCodeAt(14);
        }

        else if (this.responseText.charCodeAt(1) == 3) {
          document.getElementById("levelBat3").innerHTML = this.responseText.charCodeAt(2);  
          document.getElementById("moistSoil3").innerHTML = Math.round(( (this.responseText.charCodeAt(3) << 7) | (this.responseText.charCodeAt(4)) ) * (65535/16383))/100;
          document.getElementById("light3").innerHTML = Math.round(( (this.responseText.charCodeAt(5) << 7) | (this.responseText.charCodeAt(6)) ) * (65535/16383))/100;
          document.getElementById("humidity3").innerHTML = (Math.round(( (this.responseText.charCodeAt(7) << 7) | (this.responseText.charCodeAt(8)) ) * (65535/16383))/100) + 35;
          document.getElementById("temp3").innerHTML = (Math.round(( (this.responseText.charCodeAt(9) << 7) | (this.responseText.charCodeAt(10)) ) * (65535/16383))/100) + 1.5;
          //document.getElementById("heatLamp3Stat").innerHTML = this.responseText.charCodeAt(12);
          if(this.responseText.charCodeAt(12) == 0){
            document.getElementById("heatLamp3Stat").innerHTML = "off";
          }
          else if (this.responseText.charCodeAt(12) == 1){
            document.getElementById("heatLamp3Stat").innerHTML = "on";
          }
          //document.getElementById("shade3Stat").innerHTML = this.responseText.charCodeAt(13);
          if(this.responseText.charCodeAt(13) == 0){
            document.getElementById("shade3Stat").innerHTML = "off";
          }
          else if (this.responseText.charCodeAt(13) == 1){
            document.getElementById("shade3Stat").innerHTML = "on";
          }
          //document.getElementById("sprink3Stat").innerHTML = this.responseText.charCodeAt(14);
          if(this.responseText.charCodeAt(14) == 0){
            document.getElementById("sprink3Stat").innerHTML = "off";
          }
          else if (this.responseText.charCodeAt(14) == 1){
            document.getElementById("sprink3Stat").innerHTML = "on";
          }
        }
  
      }
    };
  request.open("GET", "request?device="+deviceNumber, "true");
  request.send();
}

function send(act1_sts){
 var xhttp = new XMLHttpRequest();
  xhttp.onreadystatechange = function() {
    if (this.readyState == 4 && this.status == 200) {
      document.getElementById("act1").innerHTML =
      this.responseText;
    }
  };
  xhttp.open("GET", "act1_set?state="+act1_sts, true);
  xhttp.send();
}

function pass(){
 var dev = new XMLHttpRequest();
  dev.onreadystatechange = function() {
    if (this.readyState == 4 && this.status == 200) {
//      selectedDevice;
//      heatLampLevel;
//      shadeActLevel;
//      sprinklerActLevel; 

    }
  };
  dev.open("GET", "dev_sel?state="+selectedDevice, true);
  dev.send();
  var heat = new XMLHttpRequest();
  heat.open("GET", "heat_sel?state="+heatLampLevel, true);
  heat.send();
  var shade = new XMLHttpRequest();
  shade.open("GET", "shade_sel?state="+shadeActLevel, true);
  shade.send();
  var sprink = new XMLHttpRequest();
  sprink.open("GET", "sprink_sel?state="+sprinklerActLevel, true);
  sprink.send();
}


function get_date() {
  
  var today = new Date();
  var date = (today.getMonth() + 1) + '-' + today.getDate() + '-' + today.getFullYear(); 
  return date;

}

function get_time() {
  var today = new Date();
  var time = today.getHours() + ":" + today.getMinutes() + ":" + today.getSeconds();
  return time
}

function table_to_CSV() {

  //variable to store final csv
  var csv_data = [];

  //get each row's data
  var rows = document.getElementsByTagName('tr');
  for(var i = 0; i < rows.length; i++) {
    // get each column data
    var cols = rows[i].querySelectorAll('td, th');

    //store rows as csv data type
    var csvrow =[];
    for(var j = 0; j < cols.length; j++){

      //get text data of each cell of a row
      // and push it to csvrow
      csvrow.push(cols[j].innerHTML);
    }

    //now combine columns with commas as delimiters
    csv_data.push(csvrow.join(","));
  }

  //combine each row data with newline char as delimiters
  csv_data = csv_data.join("\n");

  //call download function to download created table
  download_CSV_file(csv_data);

}


function download_CSV_file(csv_data) {

  //Create CSV file object and feed our csv_data into it
  CSV_file = new Blob([csv_data], {type: "text/csv"});

  //create to temporary link to initiate download process
  var temp_link = document.createElement('a');

  //download CSV
  temp_link.download = "Sensor Data.csv";
  var url = window.URL.createObjectURL(CSV_file);
  temp_link.href = url;

  //shouldnt display this link
  temp_link.style.display = "none";
  document.body.appendChild(temp_link);

  //automatically click link to trigger download
  temp_link.click();
  document.body.removeChild(temp_link);

}

var counter = 0;
var startDelay = 0;

var selectedDevice = 0;

function device_select(x) {console.log("called function");
  selectedDevice = x;
  console.log(selectedDevice);
  document.getElementById("deviceCell").innerHTML = x;
}

var heatLampLevel;

function heatLamp_set(x) {
  heatLampLevel = x;
  if(x == 1){ y = "on";}
    else if (x == 0) {y = "off";}

  document.getElementById("heatLampCell").innerHTML = y;

}

var shadeActLevel;

function shadeAct_set(x) {
  shadeActLevel = x;
  if(x == 1){ y = "on";}
    else if (x == 0) {y = "off";}
  document.getElementById("shadeActCell").innerHTML = y;

}

var sprinklerActLevel;

function sprinklerAct_set(x) {
  sprinklerActLevel = x;
  if(x == 1){ y = "on";}
    else if (x == 0) {y = "off";}
  document.getElementById("sprinklerActCell").innerHTML = y;

}


</script>
</body>
</html>
)=====";
